module Gif2lgtm
  module Main
    module_function
    LOOP_COUNT = 0 # infinite loop

    def start(img_path)
      create(compsite(img_path), img_path)
    end

    def compsite(img_path)
      gif = Magick::ImageList.new
      images = Magick::ImageList.new(img_path)
      orig_size_lgtm = Magick::ImageList.new(File.expand_path('../../images/lgtm.png', __dir__))
      lgtm = orig_size_lgtm.resize_to_fit(images.first.columns, images.first.rows)

      images.each do |image|
        gif.push(
          Magick::Image.from_blob(image.to_blob)[0].composite(
            lgtm,
            Magick::CenterGravity,
            Magick::OverCompositeOp))
      end

      gif
    end

    def create(gif, img_path)
      gif.iterations = LOOP_COUNT
      result_path = "#{File.dirname(img_path)}/lgtm#{SecureRandom.hex(5)}_#{File.basename(img_path)}"

      gif.optimize_layers(Magick::OptimizeLayer).write(result_path)
      puts <<~MESSAGE
        =======================================================
        Lgtm created. path: #{result_path}
        =======================================================

      MESSAGE
    end
  end
end
